#include <PID_v1.h>

int Pot1 = A2;

int BlueLed = 2;
int GreenLed = 3;
int RedLed = 4;

int RPWM_Output = 6; // Arduino PWM output pin 6; connect to IBT-2 pin 1 (RPWM)
int LPWM_Output = 5; // Arduino PWM output pin 5; connect to IBT-2 pin 2 (LPWM)
int Ren = 9;         // Enabling Right motion
int Len = 10;        // Enabling Left motion
int LPWM;
int RPWM;

int RX = 7; // Channel1 value
int RXValue;
int RXValueMapped;
int RXActive;

String SetpointString;

double Setpoint;
double Input;
double Output;

unsigned long PrMillis;
unsigned long Timer;

int BlinkVal = 500;
int BlinkVal2 = 100;

PID PIDController1(&Input, &Output, &Setpoint,0.25,0.25,0.01, DIRECT);  //Working values1: P= 0.25 I= 0.3 D= 0 //Working values2: P= 0.25 I= 0.2 D= 0.01

void setup() 
{
  pinMode(BlueLed, OUTPUT);
  pinMode(GreenLed, OUTPUT);
  pinMode(RedLed, OUTPUT);
  
  pinMode(RPWM_Output, OUTPUT);
  pinMode(LPWM_Output, OUTPUT);
  pinMode(Ren, OUTPUT);
  pinMode(Len, OUTPUT);
  pinMode(RX, INPUT);

  digitalWrite(BlueLed, LOW);
  digitalWrite(GreenLed, LOW);
  digitalWrite(RedLed, LOW);
  delay(BlinkVal);
  digitalWrite(RedLed, HIGH);
  delay(BlinkVal);
  digitalWrite(RedLed, LOW);
  delay(BlinkVal);
  digitalWrite(RedLed, HIGH);
  delay(BlinkVal);
  digitalWrite(RedLed, LOW);
  delay(BlinkVal);
  digitalWrite(RedLed, HIGH);
  delay(BlinkVal);
  digitalWrite(RedLed, LOW);
  delay(BlinkVal);
 
  
  Input = analogRead(Pot1);
  Setpoint = 500;

  PIDController1.SetMode(AUTOMATIC);
  PIDController1.SetOutputLimits(-250, 250);

  Serial.begin(9600);
}

void loop() 
{ 

  unsigned long CurrentMillis = millis();

  Timer = CurrentMillis - PrMillis;
  
  Input = analogRead(Pot1);
  PIDController1.Compute();

  RXValue = pulseIn (RX, HIGH, 50000);
  RXValueMapped = map(RXValue, 1000, 1900, 300, 700);
  Setpoint = RXValueMapped;


  if (abs(Input - Setpoint) <= 10){
    if (CurrentMillis - PrMillis >= 2000){
         PIDController1.SetMode(MANUAL);  //Turn PIDcontroller1 OFF when the the input (potentiometer) is close to the setpoint to avoid constant jitter of the servo
         digitalWrite(Ren, LOW);
         digitalWrite(Len, LOW);
         Output = 0;
         LPWM = 0;
         RPWM = 0;
    }
  }

  else if (abs(Input - Setpoint) > 11){
    PrMillis = CurrentMillis;
    PIDController1.SetMode(AUTOMATIC);  //Turn PIDcontroller1 ON when the the difference between the Input and setpoint is greater than 10
  }


  if (RXValue < 1900 && RXValue > 1000){
    digitalWrite(Ren, HIGH);
    digitalWrite(Len, HIGH);
    digitalWrite(RedLed, LOW);
    analogWrite(GreenLed, 5);
    RXActive = true;
  }
  else{
    digitalWrite(Ren, LOW);
    digitalWrite(Len, LOW);
    digitalWrite(RedLed, HIGH);
    digitalWrite(GreenLed, LOW);
    RXActive = false;
    LPWM = 0;
    RPWM = 0;
    Setpoint = Input;
    Output = 0;
  }

  while(Serial.available()) {
    SetpointString = Serial.readString();
    Setpoint = SetpointString.toDouble();
  }

  if (Output < 0 && RXActive == true)
  {
    // reverse rotation
    RPWM = -(Output);
    LPWM = 0;
    digitalWrite(Ren, HIGH);
    analogWrite(LPWM_Output, 0);
    analogWrite(RPWM_Output, RPWM);
  }
  else if (Output > 1 && RXActive == true)
  {
    // forward rotation
    LPWM = (Output);
    RPWM = 0;
    digitalWrite(Len, HIGH);
    analogWrite(LPWM_Output, LPWM);
    analogWrite(RPWM_Output, 0);
  }

  
  Serial.print("Input = ");
  Serial.print(Input);
  Serial.print("  Setpoint = ");
  Serial.print(Setpoint);
  Serial.print("  Output = ");
  Serial.print(Output);
  Serial.print("  RPWM = ");
  Serial.print(RPWM);
  Serial.print("  LPWM = ");
  Serial.print(LPWM);
  Serial.print("  RXVal = ");
  Serial.println(RXValueMapped);
  //Serial.print("  timer = ");
  //Serial.println(Timer);

}
